security:
    # https://symfony.com/doc/current/security.html#where-do-users-come-from-user-providers

    providers:
        custom:
        #On indique qu'on récupère nos User via une entité doctrine
        #et que la propriété email sera utilisée comme username
            entity:
                class: App\Entity\User
                property: username
        
    encoders:
        App\Entity\User: 
            algorithm: bcrypt
            cost: 12  

    firewalls:
        dev:
            pattern: ^/(_(profiler|wdt)|css|images|js)/
            security: false
        login:
            pattern:  ^/api/login
            stateless: true
            anonymous: true
            json_login:
                check_path: /api/login_check
                success_handler: lexik_jwt_authentication.handler.authentication_success
                failure_handler: lexik_jwt_authentication.handler.authentication_failure
        main:
            pattern:   ^/
            anonymous: true
            stateless: true
            guard:
                authenticators:
                    - lexik_jwt_authentication.jwt_token_authenticator

            # activate different ways to authenticate

            # http_basic: true
            # https://symfony.com/doc/current/security.html#a-configuring-how-your-users-will-authenticate

            # form_login: true
            # https://symfony.com/doc/current/security/form_login_setup.html

    # Easy way to control access for large sections of your site
    # Note: Only the *first* access control that matches will be used
    access_control:
    access_control:
        - { path: ^/api/login, roles: IS_AUTHENTICATED_ANONYMOUSLY }
        - { path: ^/apiDocumentaion, roles: ROLE_USER, methods: [GET,POST,PUT,DELETE,PATCH] }
        - { path: ^/apiCategory, roles: ROLE_USER, methods: [GET,POST,PUT,DELETE,PATCH] }